package eu.dnetlib.irishmonitorservice.controllers;

import eu.dnetlib.irishmonitorservice.configuration.properties.StatsToolProperties;
import eu.dnetlib.irishmonitorservice.entities.StakeholderPublications;
import eu.dnetlib.irishmonitorservice.utils.StatsToolUtils;
import eu.dnetlib.uoamonitorservice.entities.Stakeholder;
import eu.dnetlib.uoamonitorservice.service.StakeholderService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

@RestController
@CrossOrigin(origins = "*")
@RequestMapping("publications")
public class StakeholderPublicationsController {

    @Autowired
    private StatsToolProperties properties;

    @Autowired
    private StakeholderService service;

    @Autowired
    private StatsToolUtils utils;

    @RequestMapping(value = "/{type}", method = RequestMethod.GET)
    public List<StakeholderPublications> getStakeholders(@PathVariable String type) throws UnsupportedEncodingException {
        List<Stakeholder> stakeholders = this.service.getStakeholdersByTypeAndRole(type, null, false);
        String url = this.properties.getUrlByType(type);
        if (url != null) {
            List<StakeholderPublications> stakeholderPublications = new ArrayList<>();
            List<List<String>> data = this.utils.getData(url);
            data.forEach(entity -> {
                String id = entity.get(1);
                stakeholders.stream().filter(stakeholder -> stakeholder.getIndex_id().equals(id)).findFirst().ifPresent(stakeholder -> stakeholderPublications.add(new StakeholderPublications(stakeholder, Integer.parseInt(entity.get(0)))));
            });
            return stakeholderPublications;
        } else {
            return stakeholders.stream().map(stakeholder -> new StakeholderPublications(stakeholder, 0)).collect(Collectors.toList());
        }
    }
}
