package eu.dnetlib.irishmonitorservice.utils;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;
import org.springframework.web.util.UriComponentsBuilder;

import java.io.UnsupportedEncodingException;
import java.net.URI;
import java.net.URLDecoder;
import java.net.URLEncoder;
import java.util.List;

@Service
public class StatsToolUtils {

    @Autowired
    private RestTemplate restTemplate;

    public List<List<String>> getData(String url) throws UnsupportedEncodingException {
        String service = url.substring(0, url.indexOf('=') + 1);
        String json = URLDecoder.decode(url.substring(url.indexOf('=') + 1), "UTF-8");
        URI uri = UriComponentsBuilder.fromUriString(service + json).build().encode().toUri();
        ResponseEntity<Data> data = restTemplate.getForEntity(uri, Data.class);
        return data.getBody().getData();
    }
}
